#include <bits/stdc++.h>
using namespace std;

int main() 
{
    int n, q; cin >> n >> q;
    vector<int> dani(n);
    vector<int> pakovanja(n);

    for (int i = 0; i < n; i++) 
    {
        cin >> dani[i] >> pakovanja[i];
    }

    vector<int> pitanja(q);
    for (int i = 0; i < q; i++) 
    {
        cin >> pitanja[i];
    }

    vector<int> kumulativna(n);
    kumulativna[0] = pakovanja[0];
    for (int i = 1; i < n; i++) 
    {
        kumulativna[i] = kumulativna[i - 1] + pakovanja[i];
    }

    for (int i = 0; i < q; i++)
     {
        int k = pitanja[i];
        int nisko = 0, visoko = n - 1;
        while (nisko <= visoko) 
        {
            int srednje = (nisko + visoko)/2;
            if (dani[srednje] <= k) 
            {
                nisko = srednje + 1;
            } 
            else 
            {
                visoko = srednje - 1;
            }
        }

        if (visoko >= 0) 
        {
            cout << kumulativna[visoko] << endl;
        } 
        else 
        {
            cout << 0 << endl;
        }
    }
    return 0;
}